Bug 1398433 - Review Request: granite - elementary GTK+ Development Library
Summary: Review Request: granite - elementary GTK+ Development Library
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Neal Gompa
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
: 1103545 (view as bug list)
Depends On:
Blocks: PantheonDesktopPackageReviews 1068850
TreeView+ depends on / blocked
 
Reported: 2016-11-24 20:58 UTC by Fabio Valentini
Modified: 2017-11-11 17:12 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2016-12-31 22:20:38 UTC
ngompa13: fedora-review+


Attachments (Terms of Use)

Description Fabio Valentini 2016-11-24 20:58:08 UTC
Spec URL: https://raw.githubusercontent.com/decathorpe/elementary-stable-rpms/14d76dd48dea3501e506ba505d2e2ec5c5943e88/specs/granite.spec

SRPM URL: https://copr-be.cloud.fedoraproject.org/results/decathorpe/elementary-stable/fedora-25-x86_64/00481142-granite/granite-0.4.0.1-5.fc25.src.rpm


Description:
An extension to GTK+ that provides several useful widgets and classes
to ease application development.


This package is needed by nearly all other elementary / Pantheon DE packages. A previous review request has not been touched in a long time (more than a year) and is now outdated anyway (https://bugzilla.redhat.com/show_bug.cgi?id=1103545), so I created a new one.

    This is my first package, so I need a sponsor.


koji scratch build for f25:
http://koji.fedoraproject.org/koji/taskinfo?taskID=16601423

The package is also built and available at one of my COPR repositories:
https://copr.fedorainfracloud.org/coprs/decathorpe/elementary-stable/


Fedora Account System Username:
decathorpe

Comment 1 Dominik 'Rathann' Mierzejewski 2016-11-25 18:34:57 UTC
I'll take this review and sponsor Fabio once he completes a couple of (non-binding) reviews.

Comment 2 Fabio Valentini 2016-11-27 13:40:32 UTC
I corrected some things I forgot to include in / remove from the .spec file - additionally, I fixed some issues that rpmlint pointed out to me.

Spec URL: https://raw.githubusercontent.com/decathorpe/fedora-packaging/f04f79b1d6f8b83e6733757f6e9cc51686c19f4e/specs/granite.spec

SRPM URL: https://copr-be.cloud.fedoraproject.org/results/decathorpe/staging/fedora-rawhide-x86_64/00481789-granite/granite-0.4.0.1-6.fc26.src.rpm

A COPR build is available here: https://copr.fedorainfracloud.org/coprs/decathorpe/staging/build/481789/

A koji scratch build is available here: http://koji.fedoraproject.org/koji/taskinfo?taskID=16647475

Comment 3 Dominik 'Rathann' Mierzejewski 2016-11-29 13:30:09 UTC
1. Why the icons and Requires: hicolor-icon-theme are there in the main package if the demo application and the desktop file are in -devel? Consequently, gtk-update-icon-cache calls should probably be moved to %post* devel, too.

2. Why are you removing these? The changelog entry does not explain.
rm -r %{buildroot}/%{_datadir}/locale/bh
rm -r %{buildroot}/%{_datadir}/locale/mo

3. There's a changelog entry "- Remove kentauros configuration file.", but I don't see anything apart from the two locales being removed.

4. desktop-file-validate %{buildroot}/%{_datadir}/applications/*.desktop
*.desktop could be changed to granite-demo.desktop, since you're explicit in the %files section already.

5. License: LGPLv3, but licensecheck says:
$ licensecheck -r . | cut -d: -f2 |sort -u
 BSD (2 clause)
 LGPL (v2 or later) (with incorrect FSF address)
 LGPL (v3 or later)
 LGPL (v3 or later) (with incorrect FSF address)
 *No copyright* BSD (3 clause)
 *No copyright* GENERATED FILE
 *No copyright* UNKNOWN
 UNKNOWN
So, it should probably be License: LGPLv3+.

Comment 4 Fabio Valentini 2016-11-29 14:19:19 UTC
1. The icons are used by GTK+ widgets in the library, not (only) by the demo application, so they are in the right place (and the scriptlets and Requires: too).

2. rpmlint complains that those 2 languages (bh: Bihari and mo: Moldovian) are not recognised and looking at the languages fedora supports, they are not in the list. The reviewer of the old granite package review also wanted translations for an unsupported language to be removed, so I thought this was the usual practice.

3. The kentauros configuration file was included as (an unused and purely informational) Source1 in the older .spec file (remnant from my packaging scripts).

4. True.

5. It seems so.


My questions:
ad 2: Should I keep translations for unsupported languages or remove them?
ad 3: Should I remove the changelog entry?
ad 4: I'll fix that
ad 5: I'll fix that, too

Comment 5 Dominik 'Rathann' Mierzejewski 2016-11-29 20:39:06 UTC
(In reply to Fabio Valentini from comment #4)
> 1. The icons are used by GTK+ widgets in the library, not (only) by the demo
> application, so they are in the right place (and the scriptlets and
> Requires: too).

OK. A short comment in the spec file could be useful for future or drive-by maintainers.

> 2. rpmlint complains that those 2 languages (bh: Bihari and mo: Moldovian)
> are not recognised and looking at the languages fedora supports, they are
> not in the list. The reviewer of the old granite package review also wanted
> translations for an unsupported language to be removed, so I thought this
> was the usual practice.

rpmlint is not 100% Fedora Packaging Guidelines compliant (it's cross-distro, after all), so its warnings are to be taken with a grain of salt. I do see both bh and mo directories in /usr/share/locale, so I don't think there's any reason to remove these translations. I'm not sure why rpmlint is saying they're unsupported. Could you post the exact message?

> 3. The kentauros configuration file was included as (an unused and purely
> informational) Source1 in the older .spec file (remnant from my packaging
> scripts).

OK.

> 4. True.
> 
> 5. It seems so.
> 
> 
> My questions:
> ad 2: Should I keep translations for unsupported languages or remove them?

Please keep them.

> ad 3: Should I remove the changelog entry?

Yes, please.

> ad 4: I'll fix that
> ad 5: I'll fix that, too

Great!

Comment 6 Fabio Valentini 2016-11-29 21:21:26 UTC
The rpmlint messages for the translations are:

    granite.x86_64: E: invalid-lc-messages-dir /usr/share/locale/bh/LC_MESSAGES/granite.mo
    granite.x86_64: E: invalid-lc-messages-dir /usr/share/locale/mo/LC_MESSAGES/granite.mo

According to the rpmlint docs, this error message means:
    Package installs localization files to /usr/share/locale/ subdirectory not corresponding to any valid language

Maybe rpmlint is not up to snuff on all the latest language ISO code changes / additions.

Most packages that use the launchpad.net translations system seem to have (complete and incomplete) translations for many languages, including those two.


I fixed the remaining issues.

Spec URL: https://raw.githubusercontent.com/decathorpe/fedora-packaging/9c815d50058135acf2e929039681bd8c0a2391c7/specs/granite.spec

SRPM URL: https://copr-be.cloud.fedoraproject.org/results/decathorpe/staging/fedora-rawhide-x86_64/00482632-granite/granite-0.4.0.1-7.fc26.src.rpm


Koji scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=16673377

COPR build for f25 and rawhide:
https://copr.fedorainfracloud.org/coprs/decathorpe/staging/build/482632/

Comment 7 Zbigniew Jędrzejewski-Szmek 2016-12-05 15:44:55 UTC
*** Bug 1103545 has been marked as a duplicate of this bug. ***

Comment 8 Fabio Valentini 2016-12-07 10:40:56 UTC
Pinging reviewer.

Comment 9 Neal Gompa 2016-12-22 23:41:28 UTC
@Rathann:

Are you still working on this review?

Comment 10 Neal Gompa 2016-12-29 03:41:33 UTC
Since there's been no response from the reviewer in almost a month, I will take over this review.

Comment 11 Neal Gompa 2016-12-29 03:56:35 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "LGPL (v2 or later) (with incorrect FSF
     address)", "*No copyright* BSD (3 clause)", "LGPL (v3 or later) (with
     incorrect FSF address)", "LGPL (v3 or later)", "BSD (2 clause)". 110
     files have unknown license. Detailed output of licensecheck in
     /home/makerpm/1398433-granite/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[-]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/share/locale/rue, /usr/share/locale/ckb,
     /usr/share/locale/rue/LC_MESSAGES, /usr/share/locale/ckb/LC_MESSAGES
[-]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/share/locale/ckb,
     /usr/share/locale/rue/LC_MESSAGES, /usr/share/locale/rue,
     /usr/share/locale/ckb/LC_MESSAGES
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: The spec file handles locales properly.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: gtk-update-icon-cache is invoked in %postun and %posttrans if package
     contains icons.
     Note: icons in granite
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 3 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package installs a %{name}.desktop using desktop-file-install or
     desktop-file-validate if there is such a file.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in granite-
     debuginfo
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
     Note: Arch-ed rpms have a total of 1167360 bytes in /usr/share
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: granite-0.4.0.1-7.fc26.x86_64.rpm
          granite-devel-0.4.0.1-7.fc26.x86_64.rpm
          granite-debuginfo-0.4.0.1-7.fc26.x86_64.rpm
          granite-0.4.0.1-7.fc26.src.rpm
granite.x86_64: W: summary-not-capitalized C elementary Development Library
granite.x86_64: E: invalid-lc-messages-dir /usr/share/locale/bh/LC_MESSAGES/granite.mo
granite.x86_64: E: invalid-lc-messages-dir /usr/share/locale/mo/LC_MESSAGES/granite.mo
granite-devel.x86_64: W: only-non-binary-in-usr-lib
granite-devel.x86_64: W: no-documentation
granite-devel.x86_64: W: no-manual-page-for-binary granite-demo
granite.src: W: summary-not-capitalized C elementary Development Library
4 packages and 0 specfiles checked; 2 errors, 5 warnings.




Rpmlint (debuginfo)
-------------------
Checking: granite-debuginfo-0.4.0.1-7.fc26.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
granite.x86_64: W: summary-not-capitalized C elementary Development Library
granite.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgranite.so.3.0.1 /lib64/libpangocairo-1.0.so.0
granite.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgranite.so.3.0.1 /lib64/libatk-1.0.so.0
granite.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgranite.so.3.0.1 /lib64/libcairo-gobject.so.2
granite.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgranite.so.3.0.1 /lib64/libgthread-2.0.so.0
granite.x86_64: E: invalid-lc-messages-dir /usr/share/locale/bh/LC_MESSAGES/granite.mo
granite.x86_64: E: invalid-lc-messages-dir /usr/share/locale/mo/LC_MESSAGES/granite.mo
granite-devel.x86_64: W: only-non-binary-in-usr-lib
granite-devel.x86_64: W: no-documentation
granite-devel.x86_64: W: no-manual-page-for-binary granite-demo
3 packages and 0 specfiles checked; 2 errors, 8 warnings.



Requires
--------
granite (rpmlib, GLIBC filtered):
    /bin/sh
    hicolor-icon-theme
    libatk-1.0.so.0()(64bit)
    libc.so.6()(64bit)
    libcairo-gobject.so.2()(64bit)
    libcairo.so.2()(64bit)
    libgdk-3.so.0()(64bit)
    libgdk_pixbuf-2.0.so.0()(64bit)
    libgee-0.8.so.2()(64bit)
    libgio-2.0.so.0()(64bit)
    libglib-2.0.so.0()(64bit)
    libgobject-2.0.so.0()(64bit)
    libgthread-2.0.so.0()(64bit)
    libgtk-3.so.0()(64bit)
    libm.so.6()(64bit)
    libpango-1.0.so.0()(64bit)
    libpangocairo-1.0.so.0()(64bit)
    rtld(GNU_HASH)

granite-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    granite(x86-64)
    libatk-1.0.so.0()(64bit)
    libc.so.6()(64bit)
    libcairo-gobject.so.2()(64bit)
    libcairo.so.2()(64bit)
    libgdk-3.so.0()(64bit)
    libgdk_pixbuf-2.0.so.0()(64bit)
    libgee-0.8.so.2()(64bit)
    libgio-2.0.so.0()(64bit)
    libglib-2.0.so.0()(64bit)
    libgobject-2.0.so.0()(64bit)
    libgranite.so.3()(64bit)
    libgthread-2.0.so.0()(64bit)
    libgtk-3.so.0()(64bit)
    libm.so.6()(64bit)
    libpango-1.0.so.0()(64bit)
    libpangocairo-1.0.so.0()(64bit)
    pkgconfig(cairo)
    pkgconfig(gdk-3.0)
    pkgconfig(gdk-pixbuf-2.0)
    pkgconfig(gee-0.8)
    pkgconfig(gio-unix-2.0)
    pkgconfig(glib-2.0)
    pkgconfig(gobject-2.0)
    pkgconfig(gthread-2.0)
    pkgconfig(gtk+-3.0)
    rtld(GNU_HASH)

granite-debuginfo (rpmlib, GLIBC filtered):



Provides
--------
granite:
    granite
    granite(x86-64)
    libgranite.so.3()(64bit)

granite-devel:
    application()
    application(granite-demo.desktop)
    granite-devel
    granite-devel(x86-64)
    pkgconfig(granite)

granite-debuginfo:
    granite-debuginfo
    granite-debuginfo(x86-64)



Source checksums
----------------
https://launchpad.net/granite/0.4/0.4.0.1/+download/granite-0.4.0.1.tar.xz :
  CHECKSUM(SHA256) this package     : 95a142a8befeedc35a089d638e759b657905508dc3007036d6c1fa3efe94c4dd
  CHECKSUM(SHA256) upstream package : 95a142a8befeedc35a089d638e759b657905508dc3007036d6c1fa3efe94c4dd


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/bin/fedora-review -b 1398433 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 12 Neal Gompa 2016-12-29 04:01:29 UTC
Gah... Slight revision:

[x]: gtk-update-icon-cache is invoked in %postun and %posttrans if package
     contains icons.
     Note: icons in granite

Comment 13 Neal Gompa 2016-12-29 04:04:04 UTC
My only nitpick is that I prefer to see the demo program in its own subpackage, but that doesn't matter one way or another in this case.

Everything else looks good.

PACKAGE APPROVED.

Comment 14 Neal Gompa 2016-12-29 04:05:33 UTC
I am also sponsoring Fabio's entry as a packager.

Comment 15 Neal Gompa 2016-12-29 04:07:00 UTC
Fabio is now sponsored into the packager group.

Comment 16 Gwyn Ciesla 2016-12-29 16:47:56 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/granite

Comment 17 Fedora Update System 2016-12-29 18:18:48 UTC
granite-0.4.0.1-7.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2016-63beec8fa0

Comment 18 Fedora Update System 2016-12-31 09:27:15 UTC
granite-0.4.0.1-7.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-63beec8fa0

Comment 19 Fedora Update System 2016-12-31 22:20:38 UTC
granite-0.4.0.1-7.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.